<head><link rel="stylesheet" href="https:\/\/distrotube.com/css/style.css">
<title># File Globbing in Linux</title>
<pre>
     __ __       _______ _______ _______ ___ _______ ___     _______ _______ 
 .--|  |  |_    |   _   |   _   |       |   |   _   |   |   |   _   |   _   |
 |  _  |   _|   |.  1   |.  l   |.|   | |.  |.  1___|.  |   |.  1___|   1___|
 |_____|____|   |.  _   |.  _   `-|.  |-|.  |.  |___|.  |___|.  __)_|____   |
                |:  |   |:  |   | |:  | |:  |:  1   |:  1   |:  1   |:  1   |
                |::.|:. |::.|:. | |::.| |::.|::.. . |::.. . |::.. . |::.. . |
                `--- ---`--- ---&#39 `---&#39 `---`-------`-------`-------`-------&#39
</pre>
<p><br/></p>
<h1>File Globbing in Linux</h1>
<p>By Derek Taylor at February 26, 2020</p>
<p><br/></p>
<p>File globbing refers to “global” patterns that specify sets of filenames with wildcard characters. Globbing is the * and ? and some other pattern matchers you may be familiar with. An example would be doing something like the following in the Bash shell:</p>
<pre>
cp *.txt /Documents/text/
</pre>
<p><br/></p>
<p>The above command moves all files that end in “.txt” from the current directory to the directory “/Documents/text/&quot. The * is a wildcard that stands for “any string of characters”. *.txt is a glob pattern. When the shell sees a glob, it will perform pathname expansion and replace the glob with matching filenames when it invokes the program.</p>
<p><br/></p>
<h2>Globbing Syntax</h2>
<pre>
Wildcard  Description
<ul>
*         matches any number of any characters including none
</ul>
?         matches any single character
[abc]     matches one character given in the bracket
[a-z]     matches one character from the range given
[!abc]    matches one character not given in the bracket
[!a-z]    matches one character not from the range given
</pre>
<p><br/></p>
<pre>
Example      Matches
Bar*         Bar, Bars, Barter
?at          Bat, bat, Cat, cat
[CB]at       Cat or Bat
File[0-9]    File1, File2, etc.
[!B]at       bat, cat, Cat
File[!4-9]   File1, File2, File3
</pre>
<p><br/></p>
<pre>
Example      Does Not Match
Bar*         FooBar, Ba, ar
?at          at
[CB]at       cat or bat
File[0-9]    File, Files, File 10
[!B]at       Bat
File[!4-9]   File4, File5, Filexx
</pre>
<p><br/></p>
<h2>Globbing in SQL</h2>
<p>SQL has the equivalent of * and ?. In SQL % equates to * and _ equates to ?. There is no equivalent to [...].</p>
<p><br/></p>
<h2>Globs Are Not Regular Expressions</h2>
<p>Though they rememble regex, glob patterns are not regular expressions. Unlike regular expressions, globbing is specifically for pattern matching filenames. Regex has much more syntax to it and is much more complicated. Also, the syntax that is shared with globbing is not the same thing in regex.</p>
